import { Provider } from "@project-serum/anchor";
import { Creator, Data } from "./metadata";
import { PublicKey, TransactionInstruction, Signer } from "@solana/web3.js";
import { InstructionResult } from ".";
export interface ICreateArweaveUrlArgs {
    payer?: PublicKey;
    name: string;
    symbol: string;
    description?: string;
    image?: string;
    creators?: Creator[];
    files?: File[];
}
export interface ICreateMetadataInstructionsArgs {
    data: Data;
    authority?: PublicKey;
    mint: PublicKey;
    payer?: PublicKey;
}
export declare class SplTokenMetadata {
    provider: Provider;
    static init(provider: Provider): Promise<SplTokenMetadata>;
    constructor(opts: {
        provider: Provider;
    });
    sendInstructions(instructions: TransactionInstruction[], signers: Signer[], payer?: PublicKey): Promise<string>;
    presignCreateArweaveUrlInstructions({ name, symbol, description, image, creators, files, payer }: ICreateArweaveUrlArgs): Promise<InstructionResult<{
        files: File[];
    }>>;
    presignCreateArweaveUrl(args: ICreateArweaveUrlArgs): Promise<{
        files: File[];
        txid: string;
    }>;
    getArweaveUrl({ txid, mint, files, uploadUrl }: {
        uploadUrl?: string;
        txid: string;
        mint: PublicKey;
        files?: File[];
    }): Promise<string>;
    createMetadataInstructions({ data, authority, mint, payer }: ICreateMetadataInstructionsArgs): Promise<InstructionResult<{
        metadata: PublicKey;
    }>>;
}
//# sourceMappingURL=splTokenMetadata.d.ts.map